SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Tests-Server'!
SystemOrganization addCategory: #'Rest-Tests-Fixtures'!
SystemOrganization addCategory: #'Rest-Tests-Client'!

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'SR 3/9/2009 15:49'!
process: anHTTPRequest
	"Takes first element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	
	pc := anHTTPRequest uri identifierPath.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [result := c perform: selector]].

	^ HTTPResponse ok entity: result asString! !

Object subclass: #RestGenericViewMock
	instanceVariableNames: 'lastMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestGenericViewMock methodsFor: 'accessing' stamp: 'cs 3/18/2009 14:35'!
lastMessage

	^ lastMessage! !

!RestGenericViewMock methodsFor: 'accessing' stamp: 'cs 3/18/2009 14:35'!
lastMessage: anObject

	lastMessage := anObject.! !

!RestGenericViewMock methodsFor: 'updating' stamp: 'cs 3/18/2009 14:35'!
update: aMessage

	super update: aMessage.
	self lastMessage: aMessage.! !

Object subclass: #RestProxyRepositoryMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestProxyRepositoryMock methodsFor: 'private' stamp: 'mig 3/13/2009 16:20'!
deleteObject: anObject

	TestObject all removeFirst .! !

!RestProxyRepositoryMock methodsFor: 'instance creation' stamp: 'topa 3/3/2009 18:32'!
getObject: aString

	^ RestProxyObject new! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'cs 3/17/2009 17:50'!
rootResources

	^ Dictionary newFrom:	{'tests' -> TestObject. 'tests2' -> TestObject2}! !

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'cs 3/17/2009 17:41'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		TestObject2 -> [:test| '/tests2/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests/{1}/secondLevelTestObjects/{2}' format: {test testObject id. test id}]}! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandlerAuth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandlerAuth class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 21:50'!
rootResources

	^ Dictionary newFrom:	{'tests' -> TestObject}! !

!RestMockResourceHttpHandlerAuth class methodsFor: 'as yet unclassified' stamp: 'mfp 3/6/2009 17:06'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests/{1}/secondLevelTestObjects/{2}' format: {test testObject id. test id}]}! !

!RestMockResourceHttpHandlerAuth methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:31'!
isAuthorized: anHeaderField

	^ true! !

!RestMockResourceHttpHandlerAuth methodsFor: 'authentication' stamp: 'topa 3/5/2009 11:25'!
needsAuthentication

	^ true! !

RestEntity subclass: #TestEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity subclass: #SecondLevelTestObject
	instanceVariableNames: 'testObject testObject2 userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 3/5/2009 17:21'!
newFrom: aDictionary

	^ self new userName: (aDictionary at: 'userName')! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'cs 4/25/2009 15:53'!
primitivePropertyNames

	^ super primitivePropertyNames, #(userName)! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'cs 4/25/2009 15:54'!
referencePropertyNames

	^ super referencePropertyNames, #(testObject)! !

!SecondLevelTestObject methodsFor: 'add/remove' stamp: 'cs 3/17/2009 18:44'!
delete

	self testObject removeSecondLevelTestObject: self.
	self testObject2 removeSecondLevelTestObject: self.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:08'!
testObject

	^ testObject! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:42'!
testObject2

	^ testObject2! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:42'!
testObject2: aTestObject

	aTestObject ifNil: [testObject2 := nil. ^ self].
	testObject2 ifNotNil: [testObject2 secondLevelTestObjects remove: self. testObject2 := nil].
	aTestObject addSecondLevelTestObject: self.
	testObject2 := aTestObject.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/16/2009 17:17'!
testObject: aTestObject

	aTestObject ifNil: [testObject := nil. ^ self].
	testObject ifNotNil: [testObject secondLevelTestObjects remove: self. testObject := nil].
	aTestObject addSecondLevelTestObject: self.
	testObject := aTestObject.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName
	^ userName! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName: aString 
	userName := aString! !

!TestEntity class methodsFor: 'instance creation' stamp: 'cs 3/17/2009 17:48'!
prepare

	| testObjectMicha |
	testObjectMicha := SecondLevelTestObject new userName: 'Micha'.
	TestObject 
		testObjects: OrderedCollection new;
		addTest: (TestObject new userName: 'Test Project'; id: 1;
			addSecondLevelTestObject: testObjectMicha; yourself);
		addTest: (TestObject new userName: 'Test3 Project3'; id: 3).
	TestObject2 
		testObjects: OrderedCollection new;
		addTest: (TestObject2 new userName: 'Test2 Project2'; id: 2;
			addSecondLevelTestObject: testObjectMicha; yourself).! !

!TestEntity methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:13'!
restUri

	^ (RestMockResourceHttpHandler uriMapping at: self class) value: self! !

TestEntity subclass: #TestObject
	instanceVariableNames: 'userName secondLevelTestObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestObject class
	instanceVariableNames: 'testObjects'!

TestObject class
	instanceVariableNames: 'testObjects'!

!TestObject class methodsFor: 'add-remove' stamp: 'topa 3/3/2009 22:08'!
addNewTest: aDictionary 

	^ self addTest: (self newFrom: aDictionary)! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
addTest: aTestObject

	self testObjects add: aTestObject.
	^ aTestObject id: self incrementId! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
all

	^ self testObjects! !

!TestObject class methodsFor: 'accessing' stamp: 'SR 4/17/2009 08:51'!
allWithDeleted

	^ self testObjects! !

!TestObject class methodsFor: 'accessing' stamp: 'cs 4/25/2009 15:54'!
collectionPropertyNames

	^ super collectionPropertyNames, #(secondLevelTestObjects)! !

!TestObject class methodsFor: 'instance creation' stamp: 'mt 3/4/2009 14:17'!
newFrom: aDictionary

	^ self new
		userName: (aDictionary at: 'userName')! !

!TestObject class methodsFor: 'accessing' stamp: 'cs 4/25/2009 15:54'!
primitivePropertyNames

	^ super primitivePropertyNames, #(userName)! !

!TestObject class methodsFor: 'add-remove' stamp: 'topa 3/3/2009 22:09'!
removeTestObject: aTestObject
	
	^ self testObjects remove: aTestObject! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
testObjects

	^ testObjects! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
testObjects: aCollection

	testObjects := aCollection.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:27'!
addNewSecondLevelTestObject: aDictionary

	^ self addSecondLevelTestObject: (SecondLevelTestObject newFrom: aDictionary)! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'cs 3/17/2009 17:30'!
addSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects add: aSecondLevelTestObject ifPresent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject
		id: aSecondLevelTestObject class incrementId;
		testObject: self.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:17'!
delete

	self class removeTestObject: self.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:11'!
initialize

	super initialize.
	self secondLevelTestObjects: OrderedCollection new.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject: nil.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects

	^ secondLevelTestObjects! !

!TestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects: anObject

	secondLevelTestObjects := anObject.! !

!TestObject methodsFor: 'accessing' stamp: 'mt 4/16/2009 16:28'!
secondLevelTestObjectsWithDeleted

	^ secondLevelTestObjects! !

!TestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:27'!
userName

	^ userName! !

!TestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:27'!
userName: anObject

	userName := anObject.! !

TestObject subclass: #TestObject2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!TestObject2 methodsFor: 'as yet unclassified' stamp: 'cs 3/17/2009 18:44'!
addSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects add: aSecondLevelTestObject ifPresent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject2: self.
	^ aSecondLevelTestObject! !

!TestObject2 methodsFor: 'as yet unclassified' stamp: 'cs 3/17/2009 18:44'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject2: nil.
	^ aSecondLevelTestObject! !

TestCase subclass: #RestSocketTestCase
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 3/3/2009 21:52'!
httpUrl

	^ 'http://www.google.com' asUrl! !

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'cs 4/27/2009 16:21'!
httpsUrl

	^ 'https://www.verisign.com/favicon.ico' asUrl! !

!RestSocketTestCase methodsFor: 'tests' stamp: 'mig 4/29/2009 10:30'!
testDefaultReturn

	self
		should: ((RestSocket get: self class httpUrl) isKindOf: RestResponse);
		should: ((RestSocket get: self class httpsUrl) isKindOf: RestResponse);
		should: ((RestSocket putDocumentFromUrl: self class httpUrl request: '' content: 'foo') isKindOf: RestResponse);
		should: ((RestSocket postDocumentFromUrl: self class httpUrl request: '' content: 'bar') isKindOf: RestResponse);
		should: ((RestSocket deleteDocumentFromUrl: self class httpUrl request: '') isKindOf: RestResponse).! !

TestCase subclass: #RestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

RestTest subclass: #RestHttpServiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestHttpServiceTest methodsFor: 'running' stamp: 'topa 2/25/2009 13:28'!
setUp
	"avoid upcall"! !

!RestHttpServiceTest methodsFor: 'tests' stamp: 'topa 2/26/2009 19:39'!
testStartAndStop
	
	RestHttpService startOn: self class port.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isKindOf: RestHttpService);
		should: RestHttpService isRunning.
	
	RestHttpService stop.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isNil);
		shouldnt: RestHttpService isRunning.! !

RestTest subclass: #RestJsonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestJsonTest methodsFor: 'as yet unclassified' stamp: 'mt 4/21/2009 10:27'!
testNumberSerialization

	#(1 1.0 1/2 20.42) do: [:num | self should: (Json readFrom: (Json render: num) readStream) = num].! !

RestTest subclass: #RestNotImplementedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestNotImplementedTest methodsFor: 'tests' stamp: 'topa 3/24/2009 15:25'!
testHTTPWrongVerb

	| response |
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.

	response := RestSocket doHTTPRequestFromUrl: (self class url, '/projects/') asUrl
		verb: 'HEAD' request: '' content: nil.
		
	self 
		should: RestHttpService isRunning;
		should: response isNotImplemented.! !

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestPerformTest methodsFor: 'running' stamp: 'topa 3/3/2009 22:02'!
setUp

	super setUp.
	RestHttpService resource
		installHandler: RestPerformHttpHandler
		on: '/'! !

!RestPerformTest methodsFor: 'tests' stamp: 'topa 3/3/2009 22:02'!
testPort

	| response |
	response := self get: 'RestHttpService/port'.
	self should: response content = RestHttpService port asString.! !

RestTest subclass: #RestProxyCollectionTest
	instanceVariableNames: 'sut testObject sut2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyCollectionTest methodsFor: 'running' stamp: 'cs 3/17/2009 18:51'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	| repository |
	super setUp.
	repository := RestProxyRepository fromString: self class url.
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.
	TestEntity prepare.
	testObject := TestObject all first.
	sut := repository getCollection: ('tests/{1}/secondLevelTestObjects' format: {testObject id}).
	sut2 := repository getCollection: ('tests2/{1}/secondLevelTestObjects' format: {TestObject2 all first id}).! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 4/25/2009 16:02'!
testAddRestObject

	| newObject size |
	newObject := Dictionary with: 'userName' -> 'harry potter'.
	size := sut size.
	sut addNew: newObject.
	self
		should: sut size = (size + 1);
		should: sut second userName = (newObject at: 'userName');
		should: testObject secondLevelTestObjects size = (size + 1);
		should: testObject secondLevelTestObjects second userName = (newObject at: 'userName').! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'mig 4/1/2009 16:56'!
testAutomaticReloadOnAdd

	| newObject size |
	size := sut size.
	newObject := testObject addNewSecondLevelTestObject: (Dictionary with: 'userName' -> 'hairy potter').
	sut reload.
	self
		should: sut size = (size + 1);
		should: sut second userName = newObject userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'test 3/17/2009 18:45'!
testDeleteRestObject

	sut remove: sut first ifAbsent: [self fail].
	self
		should: sut isEmpty;
		should: testObject secondLevelTestObjects isEmpty.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 3/17/2009 16:54'!
testGetRestObjects

	| done |
	done := false.
	sut do: [:each | done := true].
	self
		should: done;
		should: sut first userName = testObject secondLevelTestObjects first userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 3/17/2009 18:49'!
testReloadRestObjects

	self should: sut first userName = testObject secondLevelTestObjects first userName.
		
	sut first delete.
	"sut reload. should be done automatically."
	self 
		should: sut isEmpty;
		should: sut2 isEmpty.! !

RestTest subclass: #RestProxyObjectTest
	instanceVariableNames: 'sut testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyObjectTest methodsFor: 'running' stamp: 'mt 3/31/2009 15:41'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler
		on: '/'.
	TestEntity prepare.
	testObject := TestObject all first.
	sut := (RestProxyObject fromPath: '/tests/' , testObject id asString) 
					repository: (RestProxyRepository fromString: self class url).
	sut repository cache at: sut restUri put: sut.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mig 4/1/2009 16:56'!
testAutomaticReload

	testObject userName: 'automatic updated.'.
	sut reload.
	self should: sut userName = 'automatic updated.'.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'topa 4/6/2009 14:32'!
testConvertingUponSend

	sut userName: ''.
	self should: sut userName = ''.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mig 3/31/2009 17:45'!
testDeferCommit

	self shouldnt: testObject userName = 'User Name A'.
	
	sut deferCommit: [
		sut userName: 'User Name A'.
		self shouldnt: testObject userName = 'User Name A'.
		sut userName: 'User Name B'.
		self shouldnt: testObject userName = 'User Name B' ].

	self should: testObject userName = 'User Name B'.
! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/31/2009 15:42'!
testDeleteRestObject

	| oldCount |
	oldCount := TestObject all size.

	sut delete.

	self should: TestObject all size = (oldCount - 1).
	[(RestProxyObject fromPath: '/tests/' , testObject id asString) title] 
		on: Exception	do: [^ self].
			
	self fail.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:55'!
testGetRestObject

	self
		should: sut userName = testObject userName;
		should: sut id = testObject id;
		should: 
			sut secondLevelTestObjects size = testObject secondLevelTestObjects size.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/31/2009 15:43'!
testRestObjectReference

	| cache sut2 sut3 oldUri |
	cache := sut repository cache.
	sut2 := sut secondLevelTestObjects first.
	oldUri := sut2 restUri.
	
	self
		should: sut = sut2 testObject;
		should: (cache includesKey: oldUri).
	
	sut3 := (RestProxyObject fromPath: '/tests/' , TestObject all second id asString) 
					repository: sut repository.
	cache at: sut3 restUri put: sut3.
	
	self
		should: TestObject all second secondLevelTestObjects isEmpty;
		should: testObject secondLevelTestObjects first testObject = testObject.
		
	sut2 testObject: sut3.

	self
		should: TestObject all second secondLevelTestObjects first testObject = TestObject all second;
		should: testObject secondLevelTestObjects isEmpty;
		should: sut3 = sut2 testObject;
		shouldnt: (cache includesKey: oldUri);
		should: (cache includesKey: sut2 restUri).! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/31/2009 15:42'!
testUpdateRestObject

	| sut2 |
	sut userName: 'New User Name!!'.
	self should: testObject userName = 'New User Name!!'.
	
	sut2 := (RestProxyObject
		fromPath: '/tests/' , testObject id asString)
		repository: sut repository.
	self should: sut2 userName = 'New User Name!!'! !

RestTest subclass: #RestProxyRepositoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyRepositoryTest methodsFor: 'running' stamp: 'mig 3/13/2009 16:03'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler
		on: '/'.
	TestEntity prepare.
	sut := RestProxyRepository fromString: self class url! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:40'!
testAdd

	| object testObject oldCount |
	oldCount := TestObject all size.
	object := sut 
		addObject: 'tests/'
		with: (TestObject new userName: 'New Test for Factory').
	testObject := TestObject all last.
	self
		should: TestObject all size = (oldCount + 1);
		should: object userName = testObject userName;
		should: object id = testObject id! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:40'!
testGet

	| object testObject |
	testObject := TestObject all first.
	object := sut getObject: 'tests/' , testObject id asString.
	self
		should: object userName = testObject userName;
		should: object id = testObject id! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:41'!
testGetCollection

	| testObjects collection |
	testObjects := TestObject all.
	collection := sut getCollection: 'tests/'.

	self should: collection size = testObjects size.
	collection do: [:eachSut | 
		self should: (testObjects anySatisfy: [:eachTestObject | 
			eachSut id = eachTestObject id 
			and: [eachSut userName = eachTestObject userName]])]! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'mt 4/21/2009 18:21'!
testReloadDeletedObject

	| collection collectionSize object mock |
	mock := RestGenericViewMock new.
	collection := sut getCollection: '/tests/'.
	collectionSize := collection size.
	object := sut getObject: '/tests/', TestObject all first id asString.
	object addDependent: mock.
	TestObject all first delete.
	object reload.
	self
		should: collection size = (collectionSize - 1);
		should: mock lastMessage = #deleted.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:41'!
testSameCollection

	| collection1 collection2 |
	collection1 := sut getCollection: 'tests/'.
	collection2 := sut getCollection: 'tests/'.

	self should: collection1 == collection2.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:41'!
testSameObject

	| object1 object2 |
	object1 := sut getObject: 'tests/', TestObject all first id asString.
	object2 := sut getObject: 'tests/', TestObject all first id asString.

	self should: object1 == object2.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:41'!
testSameObjectInHierachy

	| object1 object2 |
	object1 := sut getObject: '/tests/', TestObject all first id asString.
	object2 := object1 secondLevelTestObjects first testObject.

	self should: object1 == object2.! !

RestTest subclass: #RestResourceAuthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestResourceAuthTest methodsFor: 'tests' stamp: 'topa 3/5/2009 15:52'!
testNeedsAuthentication

	| response |
	RestHttpService resource
		installHandler: RestMockResourceHttpHandlerAuth "has needsAuthentication true"
		on: '/'.
	response := self get: 'tests' request: ''.
	self should: response responseCode = 401.
	response := self get: 'tests' request: self class auth.
	self should: response responseCode = 200.
! !

!RestResourceAuthTest methodsFor: 'tests' stamp: 'topa 3/5/2009 12:52'!
testNeedsNoAuthentication

	| response |
	RestHttpService resource
		installHandler: RestMockResourceHttpHandler  "has needsAuthentication false"
		on: '/'.
	response := self get: 'tests'.
	self should: response responseCode = 200.! !

RestTest subclass: #RestResourceGetDepthTest
	instanceVariableNames: 'testObject secondLevelTestObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/24/2009 11:35'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.
	TestEntity prepare.
	testObject := TestObject all first.
	secondLevelTestObject := testObject secondLevelTestObjects first.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 12:21'!
testGetCollectionWithDepth1

	| response |	
	response := Json readFrom:
		(self get: testObject restUri, '/secondLevelTestObjects?depth=1')
		content readStream.
	self
		should: response isCollection;
		should: response first isString;
		should: response first = secondLevelTestObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 13:12'!
testGetCollectionWithDepth2

	| response secondLevel |	
	response := Json readFrom:
		(self get: testObject restUri, '/secondLevelTestObjects?depth=2')
		content readStream.
	secondLevel := Json readFrom: (self get: secondLevelTestObject restUri) content readStream.
	self
		should: response isCollection;
		should: response first isDictionary;
		should: response first = secondLevel.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 12:04'!
testGetWithDepth0

	| response |	
	response := Json readFrom: (self get: testObject restUri, '?depth=0') content readStream.
	self
		should: response isString;
		should: response = testObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 13:15'!
testGetWithDepth1

	| response |	
	response := Json readFrom: (self get: testObject restUri, '?depth=1') content readStream.
	self
		should: response isDictionary;
		should: (response at: 'col secondLevelTestObjects') isString.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 12:06'!
testGetWithDepth2

	| test |	
	test := Json readFrom: (self get: testObject restUri, '?depth=2') content readStream.
	self
		should: test isDictionary;
		should: (test at: 'col secondLevelTestObjects') isCollection;
		should: (test at: 'col secondLevelTestObjects') first isString;
		should: (test at: 'col secondLevelTestObjects') first = secondLevelTestObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 12:05'!
testGetWithDepth3

	| test secondLevel |	
	test := Json readFrom: (self get: testObject restUri, '?depth=3') content readStream.
	secondLevel := Json readFrom: (self get: secondLevelTestObject restUri) content readStream.
	self
		should: test isDictionary;
		should: (test at: 'col secondLevelTestObjects') isCollection;
		should: (test at: 'col secondLevelTestObjects') first isDictionary;
		should: (test at: 'col secondLevelTestObjects') first = secondLevel.! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:15'!
auth

	^ 'Authorization: Basic dGVzdDoxMjM=', String crlf! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'SR 3/9/2009 10:52'!
authUser2Pass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login2, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:48'!
authUserPass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
host

	^ 'localhost'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
ip

	^ '127.0.0.1'! !

!RestTest class methodsFor: 'testing' stamp: 'mfp 3/6/2009 13:40'!
isAbstract

	^ self == RestTest! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:47'!
login

	^ 'test.user@example.com'! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'SR 3/9/2009 10:50'!
login2

	^ 'test.user2@example.com'! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'mig 4/1/2009 15:05'!
login3

	^ 'test.user3@example.com'! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:47'!
password

	^ 'foobar123'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
port

	^ 58082! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 15:29'!
url
	
	^ 'http://{1}:{2}@{3}:{4}/' format: {self login encodeForHTTP. self password encodeForHTTP. self ip. self port}! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:02'!
delete: aPath
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
delete: aPath request: aRequest
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/5/2009 15:50'!
get: aPath
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ RestSocket
		getDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/5/2009 15:52'!
get: aPath request: aRequest
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ RestSocket
		getDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 21:58'!
jsonDataFrom: someFields
	"Create a string for all fields in the dictionary in JSON."
	
	| stream |
	stream := TextStream with: String new.
	(Dictionary newFrom: someFields) jsonWriteOn: stream.	
	^ stream contents! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:03'!
post: aPath content: aContent
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
post: aPath content: aContent request: aRequest
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service.
	 Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:03'!
put: aPath content: aContent
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
put: aPath content: aContent request: aRequest
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'running' stamp: 'topa 3/3/2009 18:37'!
setUp

	super setUp.
	RestHttpService startOn: self class port.
! !

!RestTest methodsFor: 'running' stamp: 'mt 3/12/2009 13:16'!
tearDown

	RestHttpService stop.
	super tearDown.! !
